; MVCOM Library Demonstration
; To sue this software connect a loop back connector to the tested serial port
; Or connect 2 PC with a serial cable and run this software on the 2 PC

XIncludeFile "Common.pb"

#BufferIn = 1024
#BufferOut = 1024

Global ComSpeed.l           ;Index of selected com speed
Global CommData.l           ;Index of selected data bit
Global CommParity.l         ;Index of selected parity
Global CommHandshake.l      ;Index of selected handshake mode

Global Hcom.l               ;Communication Handle

; -----------------------------------------------------------------------------------------------

Procedure Affiche01()
  
  SetGadgetState(#List01,ComSpeed)
  SetGadgetState(#List02,ComData)
  SetGadgetState(#List03,ComParity)
  SetGadgetState(#List04,ComHandshake)
  SetGadgetState(#List05,0)

EndProcedure

; ----------------------------------------------------------------------------
; Procedure:  Init01()
; Parameter:  No 
; Action:     Init gadgets list and some variables
; Return:     
; ----------------------------------------------------------------------------

Procedure Init01()
  
  Boucle.l = 0
  Chaine.s = ""
  
  ClearGadgetItemList(#List01)
  AddGadgetItem(#List01,-1,"300 Bauds")
  AddGadgetItem(#List01,-1,"1200 Bauds")
  AddGadgetItem(#List01,-1,"2400 Bauds")
  AddGadgetItem(#List01,-1,"4800 Bauds")
  AddGadgetItem(#List01,-1,"9600 Bauds")
  AddGadgetItem(#List01,-1,"19200 Bauds")
  
  
  ClearGadgetItemList(#List02)
  AddGadgetItem(#List02,-1,"8 Bits")
  AddGadgetItem(#List02,-1,"7 Bits")

    
  ClearGadgetItemList(#List03)
  AddGadgetItem(#List03,-1,"None")
  AddGadgetItem(#List03,-1,"Even")
  AddGadgetItem(#List03,-1,"Odd")
  
  ClearGadgetItemList(#List04)
  AddGadgetItem(#List04,-1,"None")
  AddGadgetItem(#List04,-1,"RTS Enable")
  AddGadgetItem(#List04,-1,"RTS / CTS")
  AddGadgetItem(#List04,-1,"Xon / Xoff")
  
  SetGadgetText(#Text01,"The quick brown fox jumps over the lazy dog!!!")
  StatusBarText(#StatusBar_0,0,"Ralisation de Marc VITRY (marc.vitry@wanadoo.fr)")

  ClearGadgetItemList(#List05)
  For Boucle = 1 To 16
    Chaine = "COM" + Str(Boucle) + ":1200,n,8,1"

    Hcom = ComOpen(Chaine,0 ,#BufferIn,#BufferOut)
    If Hcom > 0
      AddGadgetItem(#List05,-1,"COM" + Str(Boucle))
      If ComClose(Hcom)
        Hcom = 0
      EndIf 
    EndIf
  Next
  
  Hcom = 0
  ComSpeed = 4      ;9600 Bauds
  ComData = 0       ;8 Bits
  ComParity = 0     ;None
  CommHandshake = 0 ;None
  
  
  Affiche01()

EndProcedure

; ----------------------------------------------------------------------------
; Procedure:  GetComDescription()
; Parameter:  No 
; Action:     Create the Communication Description string (Ex: COM1:9600,N,8,1)
; Return:     String
; ----------------------------------------------------------------------------
Procedure.s GetComDescription()

  Chaine.s = ""
  Chaine = GetGadgetText(#List05) + ":"
  
  Select GetGadgetState(#List01)
    Case 0
      Chaine = Chaine + " baud=300"
    Case 1
      Chaine = Chaine + " baud=1200"
    Case 2
      Chaine = Chaine + " baud=2400"
    Case 3
      Chaine = Chaine + " baud=4800"
    Case 4
      Chaine = Chaine + " baud=9600"
    Case 5
      Chaine = Chaine + " baud=19200"
  EndSelect 
  
  Select GetGadgetState(#List03)
    Case 0
      Chaine = Chaine + " parity=N"
    Case 1
      Chaine = Chaine + " parity=E"
    Case 2
      Chaine = Chaine + " parity=O"
  EndSelect

  Select GetGadgetState(#List02)
    Case 0
      Chaine = Chaine + " data=8 stop=1"
    Case 1
      Chaine = Chaine + " data=7 stop=1"
  EndSelect

  CommHandshake = GetGadgetState(#List04)
  Debug Chaine
  ProcedureReturn Chaine

EndProcedure

Procedure DisplayComError()

  MyString.s = ""
  Result.l = ComGetCommError(Hcom)
  
  If Result & #ComError_RxOver = #ComError_RxOver : MyString = "An input buffer overflow has occurred" : EndIf
  If Result & #ComError_OverRun = #ComError_OverRun : MyString = "A character-buffer overrun has occurred" : EndIf
  If Result & #ComError_RxParity = #ComError_RxParity : MyString = "The hardware detected a parity error" : EndIf
  If Result & #ComError_Frame = #ComError_Frame : MyString = "The hardware detected a framing error" : EndIf
  If Result & #ComError_Break = #ComError_Break : MyString = "The hardware detected a break condition" : EndIf
  If Result & #ComError_TxFull = #ComError_TxFull : MyString = "The output buffer was full" : EndIf
  If Result & #ComError_IOE = #ComError_IOE : MyString = "An I/O error occurred during communications with the device" : EndIf
  If Result & #ComError_WaitingCTS = #ComError_WaitingCTS : MyString = "Waiting  CTS" : EndIf
  If Result & #ComError_WaitingDSR = #ComError_WaitingDSR : MyString = "Waiting  DSR" : EndIf
  If Result & #ComError_WaitingRLSD = #ComError_WaitingRLSD : MyString = "Waiting  RLSD" : EndIf
  If Result & #ComError_XoffReceived = #ComError_XoffReceived : MyString = "Waiting  because the XOFF character was received" : EndIf
  If Result & #ComError_XoffSent = #ComError_XoffSent : MyString = "Waiting  because the XOFF character was transmitted" : EndIf
  If Result & #ComError_EOFSent = #ComError_EOFSent : MyString = "EOF character has been received" : EndIf
  
  MessageRequester("Message",MyString)

EndProcedure
; ----------------------------------------------------------------------------
; Procedure:  TimerProc()
; Parameter:  See SetTimer API Function
; Action:     Read and display data if present in the input buffer
;             Check and display status of CTS, DSR and DCD
; Return:     None
; ----------------------------------------------------------------------------
Procedure TimerProc(WindowID.l, nIDEvent.l, uElapse.l, lpTimerFunc.l)
  
  If Hcom > 0
    KillTimer_(WindowID(#Window_0),1)
    Car.s = " "
    Buffer.b = 0
    Chaine.s = GetGadgetText(#Label01)

    ;Boucle    
    While ComInputBufferCount(Hcom) > 0
      If ComRead(Hcom,@Buffer,1)    ;Read Byte
        Chaine = Chaine + Chr(Buffer)
        SetGadgetText(#Label01,Chaine)
      Else
        
      EndIf
    Wend 
    
    StartDrawing(WindowOutput())        ;Draw Green or Red LED
      If ComGetCTS(Hcom)
        Box(210,60,20,18, RGB(0,255,0))
      Else
        Box(210,60,20,18, RGB(255,0,0))
      EndIf
      If ComGetDSR(Hcom)
        Box(210,80,20,18, RGB(0,255,0))
      Else
        Box(210,80,20,18, RGB(255,0,0))
      EndIf
      If ComGetDCD(Hcom)
        Box(210,100,20,18, RGB(0,255,0))
      Else
        Box(210,100,20,18, RGB(255,0,0))
      EndIf

      StopDrawing()
      SetTimer_(WindowID(#Window_0),1,1,@TimerProc()) ;Init a 100 milisecond timer
  Else
    StartDrawing(WindowOutput())        ;Draw Red LED
      Box(210,60,20,18, RGB(255,0,0))
      Box(210,80,20,18, RGB(255,0,0))
      Box(210,100,20,18, RGB(255,0,0))
    StopDrawing()
  
  EndIf

EndProcedure

; -----------------------------------------------------------------------------------------------
; Main loop
; -----------------------------------------------------------------------------------------------

Open_Window_0()
Init01()

SetTimer_(WindowID(#Window_0),1,1,@TimerProc()) ;Init a 100 milisecond timer

Repeat
  
  Event = WaitWindowEvent()
  If Event = #PB_EventGadget
        
    GadgetID = EventGadgetID()
    
    Select GadgetID
    
      Case #Key00                             ;Quit
        
        If Hcom > 0 
          ComClose(Hcom)                      ;Close the Communication Port
        EndIf
        KillTimer_(WindowID(#Window_0),1)     ;Kill the Timer
        CloseWindow(#Window_0)                ;Close the window
        End
        
      Case #Key01                             ;Send and Get Data
        
        If Hcom > 0                           ;Send the string to Communication Port
          Chaine.s = GetGadgetText(#Text01)
          SetGadgetText(#Label01,"")         
          If ComWrite(Hcom,@Chaine,Len(Chaine))
          Else
            DisplayComError()
          EndIf
        Else
          MessageRequester("Message","Communication Port not open!!!",#MB_ICONEXCLAMATION)
        EndIf
        
      Case #Key02                               ;Set RTS ON
        If Hcom > 0
          ComSetRTS(Hcom,#True)
        EndIf

      Case #Key03                               ;Set RTS OFF
        If Hcom > 0
          ComSetRTS(Hcom,#False)
        EndIf
      
      Case #Key04                               ;Set DTR ON
         If Hcom > 0
          ComSetDTR(Hcom,#True)
        EndIf
     
      Case #Key05                               ;Set DTR OFF
         If Hcom > 0
          ComSetDTR(Hcom,#False) 
        EndIf
     
      Case #Key06                               ;Open Com Port
        
        If hCom > 0                             ;If one port is used then close it
          If ComClose(hCom)
            hCom = 0
          EndIf
        EndIf 
         
        CommHandshake = GetGadgetState(#List04)
        hCom = ComOpen(GetComDescription(),CommHandshake ,#BufferIn,#BufferOut)
        If hCom = -1
          MessageRequester("Message","Communication Port not available!!!",#MB_ICONEXCLAMATION)
        EndIf
        
      Case #Key07             ;Close Com Port
        
        If hCom > 0
          If ComClose(hCom)
            hCom = 0
          EndIf
        EndIf 
        
    EndSelect
        
  EndIf
  
Until Event = #PB_EventCloseWindow

End 
; IDE Options = PureBasic v3.94 (Windows - x86)
; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 181
; FirstLine = 154
; Folding = -
; EnableAsm
; EnableNT4
; EnableXP
; UseIcon = 10_ico_4.ico
; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 157
; FirstLine = 131
; Folding = -
; EnableNT4
; EnableXP
; DisableDebugger